package com.explause.aopExamples;

import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.AfterThrowing;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;

@Aspect
public class HelloWorldAspect {
	@Pointcut("execution(* com.explause.aopExamples.HelloWorld.*(..))")
	private void selectAll() {}
	
	@Before("selectAll()")
	public void beforeAdvice(){
		System.out.println("In the beforeAdvice.");
	}
	@After("selectAll()")
	public void afterAdvice(){
		System.out.println("In the afterAdvice.");
	}
	@AfterReturning(pointcut = "selectAll()", returning = "retVal")
	public void afterReturningAdvice(Object retVal) {
		System.out.println("In the afterReturningAdvice:" + retVal.toString() );
	}
	@AfterThrowing(pointcut = "selectAll()", throwing = "ex")
	public void AfterThrowingAdvice(Exception ex){
		System.out.println("In the AfterThrowingAdvice: " + ex.toString());   
	}
}